
extern "C"{
  #include "main.h"
}

const int RTSPin = 23;     //RTS
const int CTSPin = 22;    //CTS
const int LEDPin1 = 25;
const int LEDPin2 = 27;

unsigned short usLCDCuiX,usLCDCuiY;
unsigned char ucLCDC_Command[100];

unsigned char ucserialDataBuff3[500];

int countgo_flag,gazou_count,gazou_count2,c;
char SwitchRetu_DOWNEDGE,SwitchRetu_UPEDGE;
char SwitchRetuOld,SwitchRetuNew;
char switch1,switch2,switch3,switch4,switch5,switch6,switch7,switch8,switch9,switch10,switch11,switch12,switch13,switch14,switch15;
int keta1,keta2,keta3,keta4,keta5;
int keta1_old,keta2_old,keta3_old,keta4_old,keta5_old;
int iCountTimer;
int stop_soft_flag;

/*sci(シリアル通信)関連*/

unsigned short inCount,outCount,usBufCount;
char rBuffer[500];
char cBuffer[500];

int fnSciInit(void){
  //sciの初期化
  
  Serial2.begin(115200);

  pinMode(RTSPin, INPUT);     //RTS
  pinMode(CTSPin, OUTPUT);    //CTS

  pinMode(LEDPin1, OUTPUT);    //LED
  pinMode(LEDPin2, OUTPUT);    //LED
  
  inCount = 0;
  outCount = 0;

}

void fnputus(char *cp){

  Serial2.print(cp);
  Serial2.print("\r");
}

void fnSerialRead(void){
        while(Serial2.available()) {
                rBuffer[inCount] = Serial2.read();
                inCount++;
                if(inCount >= 500){
                        inCount = 0;
                }
        }
}

/*RTS判定*/
int fnRTSRead(void){
  if(digitalRead(RTSPin) == HIGH) return 1;
  else return 0;
}

/*------------------------------------------
関数名　fnInit
説明
　各機能の初期化を行います。
------------------------------------------*/
int fnInit(void){

  //Sciの初期化
  fnSciInit();

   //command_LCDClibの初期化
  fnLCDCInit();

  stop_soft_flag = 0;
}
/*------------------------------------------
関数名　fnMeasurement_Count
説明
　引き渡し数によって、表示する数値の画像を変更する関数。
------------------------------------------*/
void fnMeasurement_Count(int countkoko,int countkoko2){

  keta3 = countkoko%10;
  keta4 = (countkoko/10)%10;
  keta5 = (countkoko/100)%10;

  fnLCDCP(0,L_NUN3_X,L_NUN_Y,20+keta5);
  fnLCDCP(0,L_NUN2_X,L_NUN_Y,20+keta4);
  fnLCDCP(0,L_NUN1_X,L_NUN_Y,20+keta3);
  fnLCDCP(0,M_NUN2_X,M_NUN_Y,30+countkoko2);
  fnLCDCP(0,M_NUN1_X,M_NUN_Y,30+countkoko2);
}

/*------------------------------------------
関数名　fnMeasurement
説明
　引き渡し数によって、表示する数値の画像を変更する関数。
------------------------------------------*/
void fnGazou_Measurement(void){
  char SW4_data;
  fnLCDCI(1);


  //------------------------------1ページ目に書き込む

  //背景を描画
  fnLCDCP(0,000,000,1);

  //000.00を表示
  fnLCDCP(0,L_NUN3_X,L_NUN_Y,20);
  fnLCDCP(0,L_NUN2_X,L_NUN_Y,20);
  fnLCDCP(0,L_NUN1_X,L_NUN_Y,20);
  fnLCDCP(0,M_NUN3_X,M_NUN_Y,52);
  fnLCDCP(0,M_NUN2_X,M_NUN_Y,30);
  fnLCDCP(0,M_NUN1_X,M_NUN_Y,30);

  //数字の後の単位を表示
  fnLCDCP(0,UNIT_X,UNIT_Y,58);  //単位表示

  //下の3つのボタンを表示
  fnLCDCP(0,MENU_X,MENU_Y,14);  //MENY表示
  fnLCDCP(0,START_X,START_Y,16);  //START表示
  fnLCDCP(0,STOP_X,STOP_Y,18);  //STOP表示
  //単位変更用の上側6このボタンを表示
  fnLCDCP(0,UNITSW1_X,UNITSW_Y,7);        //V
  fnLCDCP(0,UNITSW2_X,UNITSW_Y,6);        //mV
  fnLCDCP(0,UNITSW3_X,UNITSW_Y,2);        //A
  fnLCDCP(0,UNITSW4_X,UNITSW_Y,11);       //mAは押してある画像を表示
  fnLCDCP(0,UNITSW5_X,UNITSW_Y,4);        //kg
  fnLCDCP(0,UNITSW6_X,UNITSW_Y,3);        //g

  //HI側の数値決定
  fnLCDCP(0,56,58,41);  //1
  fnLCDCP(0,76,58,47);    //7
  fnLCDCP(0,96,58,40);    //0
  fnLCDCP(0,116,58,54);    //.
  fnLCDCP(0,136,58,40);    //0
  fnLCDCP(0,156,58,40);    //0

  //LO側の数値決定
  fnLCDCP(0,344,58,40);    //0
  fnLCDCP(0,364,58,44);    //4
  fnLCDCP(0,384,58,40);    //0
  fnLCDCP(0,404,58,54);    //.
  fnLCDCP(0,424,58,40);    //0
  fnLCDCP(0,444,58,40);    //0

  fnLCDCH(1); //表示するページをページ1に変更し、既にページ1に書き終わっている画面を表示する。

  //使用変数の初期化

  SW4_data = 0;
  gazou_count = 0;
  gazou_count2 = 0;
  countgo_flag = 0;

  keta1 = 0;
  keta2 = 0;
  keta3 = 0;
  keta4 = 0;
  keta5 = 0;

  keta1_old = 0;
  keta2_old = 0;
  keta3_old = 0;
  keta4_old = 0;
  keta5_old = 0;

  //カウントアップのループ開始
  while(1){
    fnSerial_Decision();//画面の指座標の確認
    usleep(10000);
    //画面に描画したスイッチが押されているか確認
    //スイッチ1の判断
    if((LCDCusX >= 20) & (LCDCusX <= 150) & (LCDCusY >= 200) & (LCDCusY <= 260)){
      switch1 = 1;
    }else{
      switch1 = 0;
    }
    //スイッチ2の判断
                if((LCDCusX >= 170) & (LCDCusX <= 310) & (LCDCusY >= 200) & (LCDCusY <= 260)){
                        switch2 = 1;
                }else{
                        switch2 = 0;
                }
    //スイッチ3の判断
                if((LCDCusX >= 330) & (LCDCusX <= 460) & (LCDCusY >= 200) & (LCDCusY <= 260)){
                        switch3 = 1;
                }else{
                        switch3 = 0;
                }
    //スイッチ4の判断
    if(countgo_flag == 0){
      if((LCDCusX >=1) & (LCDCusX <= 479) & (LCDCusY >= 1) & (LCDCusY <= 60)){
        if((LCDCusX >= 1) & (LCDCusX <=79)){
          SW4_data = 1;
        }
        if((LCDCusX >= 80) & (LCDCusX <=159)){
                                        SW4_data = 2;
                                }
        if((LCDCusX >= 160) & (LCDCusX <=239)){
                                        SW4_data = 3;
                                }
        if((LCDCusX >= 240) & (LCDCusX <=319)){
                                        SW4_data = 4;
                                }
        if((LCDCusX >= 320) & (LCDCusX <=399)){
                                        SW4_data = 5;
                                }
        if((LCDCusX >= 400) & (LCDCusX <=479)){
                                        SW4_data = 6;
                                }

        switch4 = 1;
      }else{
        switch4 = 0;
      }
    }


    SwitchRetuOld = SwitchRetuNew;  //ループ一週前のスイッチ状態を保存
    SwitchRetuNew = (switch1 | switch2<<1 | switch3<<2 | switch4<<3 );

    SwitchRetu_UPEDGE = ((SwitchRetuOld | SwitchRetuNew)^SwitchRetuOld);  //立ち上がり（押された時）の判定
    SwitchRetu_DOWNEDGE =((SwitchRetuOld | SwitchRetuNew)^SwitchRetuNew); //立下り（離されたとき）判定



    if(countgo_flag == 0){
      //カウントアップのフラグが下りているときだけスイッチを反応させ、その制御を以下に記述
      if(SwitchRetu_UPEDGE & SWITCH1_UP){ //スイッチ1の立ち上がりエッジ検出
        fnLCDCP(0,MENU_X,MENU_Y,15);
      }
      if(SwitchRetu_DOWNEDGE & SWITCH1_UP){ //スイッチ1の立下りエッジ検出
        fnLCDCP(0,MENU_X,MENU_Y,14);
        SwitchRetu_DOWNEDGE = 0x0000;

        stop_soft_flag = 1;   //このソフトを止めるフラグを立てる。
        return; //この関数を抜ける。
      }

      if(SwitchRetu_UPEDGE & SWITCH2_UP){
        if(countgo_flag == 0){
          fnLCDCP(0,START_X,START_Y,17);  //START表示　押されている画像
        }
      }
      if(SwitchRetu_DOWNEDGE & SWITCH2_UP){
        fnLCDCP(0,START_X,START_Y,16);
        //000.00を表示
              fnLCDCP(0,L_NUN3_X,L_NUN_Y,20);
              fnLCDCP(0,L_NUN2_X,L_NUN_Y,20);
              fnLCDCP(0,L_NUN1_X,L_NUN_Y,20);
              fnLCDCP(0,M_NUN2_X,M_NUN_Y,30);
              fnLCDCP(0,M_NUN1_X,M_NUN_Y,30);

        gazou_count = 0;
        countgo_flag = 1;

      }

      if(SwitchRetu_UPEDGE & SWITCH4_UP){
        if(SW4_data == 1){
          fnLCDCP(0,UNITSW1_X,UNITSW_Y,13); //Vを押してある画像
          fnLCDCP(0,UNIT_X,UNIT_Y,60);
          printf("V_modo\r\n");

          fnLCDCP(0,UNITSW2_X,UNITSW_Y,6);
          fnLCDCP(0,UNITSW3_X,UNITSW_Y,2);
          fnLCDCP(0,UNITSW4_X,UNITSW_Y,5);
          fnLCDCP(0,UNITSW5_X,UNITSW_Y,4);
          fnLCDCP(0,UNITSW6_X,UNITSW_Y,3);
        }
                                if(SW4_data == 2){
                                        fnLCDCP(0,UNITSW2_X,UNITSW_Y,12); //mVをおしてある画像
                                        fnLCDCP(0,UNIT_X,UNIT_Y,59);
          printf("mV_modo\r\n");

                                        fnLCDCP(0,UNITSW1_X,UNITSW_Y,7);
                                        fnLCDCP(0,UNITSW3_X,UNITSW_Y,2);
                                        fnLCDCP(0,UNITSW4_X,UNITSW_Y,5);
                                        fnLCDCP(0,UNITSW5_X,UNITSW_Y,4);
                                        fnLCDCP(0,UNITSW6_X,UNITSW_Y,3);
                                }
                                if(SW4_data == 3){
                                        fnLCDCP(0,UNITSW3_X,UNITSW_Y,8);  //Aを押してある画像
                                        fnLCDCP(0,UNIT_X,UNIT_Y,55);
          printf("A_modo\r\n");

                                        fnLCDCP(0,UNITSW1_X,UNITSW_Y,7);
                                        fnLCDCP(0,UNITSW2_X,UNITSW_Y,6);
                                        fnLCDCP(0,UNITSW4_X,UNITSW_Y,5);
                                        fnLCDCP(0,UNITSW5_X,UNITSW_Y,4);
                                        fnLCDCP(0,UNITSW6_X,UNITSW_Y,3);
                                }
                                if(SW4_data == 4){
                                        fnLCDCP(0,UNITSW4_X,UNITSW_Y,11); //mAを押してある画像
                                        fnLCDCP(0,UNIT_X,UNIT_Y,58);
          printf("mA_modo\r\n");

                                        fnLCDCP(0,UNITSW1_X,UNITSW_Y,7);
                                        fnLCDCP(0,UNITSW2_X,UNITSW_Y,6);
                                        fnLCDCP(0,UNITSW3_X,UNITSW_Y,2);
                                        fnLCDCP(0,UNITSW5_X,UNITSW_Y,4);
                                        fnLCDCP(0,UNITSW6_X,UNITSW_Y,3);
                                }
        if(SW4_data == 5){
                                        fnLCDCP(0,UNITSW5_X,UNITSW_Y,10); //kgを押してある画像
                                        fnLCDCP(0,UNIT_X,UNIT_Y,57);
          printf("kg_modo\r\n");

                                        fnLCDCP(0,UNITSW1_X,UNITSW_Y,7);
                                        fnLCDCP(0,UNITSW2_X,UNITSW_Y,6);
                                        fnLCDCP(0,UNITSW3_X,UNITSW_Y,2);
                                        fnLCDCP(0,UNITSW4_X,UNITSW_Y,5);
                                        fnLCDCP(0,UNITSW6_X,UNITSW_Y,3);
                                }
                                if(SW4_data == 6){
                                        fnLCDCP(0,UNITSW6_X,UNITSW_Y,9);  //gを押してある画像
                                        fnLCDCP(0,UNIT_X,UNIT_Y,56);
          printf("g_modo\r\n");

                                        fnLCDCP(0,UNITSW1_X,UNITSW_Y,7);
                                        fnLCDCP(0,UNITSW2_X,UNITSW_Y,6);
                                        fnLCDCP(0,UNITSW3_X,UNITSW_Y,2);
                                        fnLCDCP(0,UNITSW4_X,UNITSW_Y,5);
                                        fnLCDCP(0,UNITSW5_X,UNITSW_Y,4);
                                }
                        }
    }



    if(SwitchRetu_UPEDGE & SWITCH3_UP){
      countgo_flag = 0;
      fnLCDCP(0,STOP_X,STOP_Y,19);
    }
    if(SwitchRetu_DOWNEDGE & SWITCH3_UP){
      fnLCDCP(0,STOP_X,STOP_Y,18);
    }

    //----------------------------STARTボタンを押されてから行う処理。
    if(countgo_flag == 1){
  //    if(iCountTimer == 0){
        iCountTimer = 50000;
        fnMeasurement_Count(gazou_count,gazou_count2);
        gazou_count++;
        gazou_count2++;
        if(gazou_count2 >= 10){
          gazou_count2 = 0;
        }
        usleep(10000);
  //    }

      if(gazou_count >= 225){
        fnMeasurement_Count(gazou_count,gazou_count2);
        fnLCDCP(0,M_NUN2_X,M_NUN_Y,32); //小数点第1位を2表示
        fnLCDCP(0,M_NUN1_X,M_NUN_Y,30); //小数点第2位を0表示
        usleep(200000);
        fnSerial_Decision();
        if((LCDCusX >= 330) & (LCDCusX <= 460) & (LCDCusY >= 200) & (LCDCusY <= 260)){
          countgo_flag = 0;
          goto OUT;
        }
        usleep(200000);
        fnLCDCP(0,M_NUN1_X,M_NUN_Y,31); //小数点第2位を1表示
        fnSerial_Decision();
        if((LCDCusX >= 330) & (LCDCusX <= 460) & (LCDCusY >= 200) & (LCDCusY <= 260)){
                                  countgo_flag = 0;
                                  goto OUT;
                          }
        usleep(200000);
                          fnLCDCP(0,M_NUN1_X,M_NUN_Y,32); //小数点第2位を2表示
                          fnSerial_Decision();
                          if((LCDCusX >= 330) & (LCDCusX <= 460) & (LCDCusY >= 200) & (LCDCusY <= 260)){
                                  countgo_flag = 0;
                                  goto OUT;
                          }
        usleep(200000);
                          fnLCDCP(0,M_NUN1_X,M_NUN_Y,33); //小数点第2位を3表示
                          fnSerial_Decision();
                          if((LCDCusX >= 330) & (LCDCusX <= 460) & (LCDCusY >= 200) & (LCDCusY <= 260)){
                                  countgo_flag = 0;
                                  goto OUT;
                          }
        usleep(200000);
                          fnLCDCP(0,M_NUN1_X,M_NUN_Y,34); //小数点第2位を4表示
                          fnSerial_Decision();
                          if((LCDCusX >= 330) & (LCDCusX <= 460) & (LCDCusY >= 200) & (LCDCusY <= 260)){
                                  countgo_flag = 0;
                                  goto OUT;
                          }
        usleep(200000);
                          fnLCDCP(0,M_NUN1_X,M_NUN_Y,35); //小数点第2位を5表示
                          fnSerial_Decision();
                          if((LCDCusX >= 330) & (LCDCusX <= 460) & (LCDCusY >= 200) & (LCDCusY <= 260)){
                                  countgo_flag = 0;
                                  goto OUT;
                          }
        usleep(200000);
                          fnLCDCP(0,M_NUN1_X,M_NUN_Y,36); //小数点第2位を6表示
                          fnSerial_Decision();
                          if((LCDCusX >= 330) & (LCDCusX <= 460) & (LCDCusY >= 200) & (LCDCusY <= 260)){
                                  countgo_flag = 0;
                                  goto OUT;
                          }
        usleep(200000);
                          fnLCDCP(0,M_NUN1_X,M_NUN_Y,37); //小数点第2位を7表示

        countgo_flag = 0;
      }
      OUT:
      ;
    }
  }
}

void setup() {
  // put your setup code here, to run once:
  fnInit();
  fnLCDC_RTSset(1);       //RTSを使用(1)  使用しない(0)
  fnLCDCt(0);
  fnLCDCt(2);
}

void loop() {
  // put your main code here, to run repeatedly:

  fnGazou_Measurement();
        
}
